#ifndef PROTOCOLS_H
#define PROTOCOLS_H

#include "symgen_types.h"
extern const struct wp_interface intf_gtk_primary_selection_device;
extern const struct wp_interface intf_gtk_primary_selection_device_manager;
extern const struct wp_interface intf_gtk_primary_selection_offer;
extern const struct wp_interface intf_gtk_primary_selection_source;
extern const struct wp_interface intf_wl_buffer;
extern const struct wp_interface intf_wl_callback;
extern const struct wp_interface intf_wl_compositor;
extern const struct wp_interface intf_wl_data_device;
extern const struct wp_interface intf_wl_data_device_manager;
extern const struct wp_interface intf_wl_data_offer;
extern const struct wp_interface intf_wl_data_source;
extern const struct wp_interface intf_wl_display;
extern const struct wp_interface intf_wl_drm;
extern const struct wp_interface intf_wl_keyboard;
extern const struct wp_interface intf_wl_output;
extern const struct wp_interface intf_wl_pointer;
extern const struct wp_interface intf_wl_region;
extern const struct wp_interface intf_wl_registry;
extern const struct wp_interface intf_wl_seat;
extern const struct wp_interface intf_wl_shell;
extern const struct wp_interface intf_wl_shell_surface;
extern const struct wp_interface intf_wl_shm;
extern const struct wp_interface intf_wl_shm_pool;
extern const struct wp_interface intf_wl_subcompositor;
extern const struct wp_interface intf_wl_subsurface;
extern const struct wp_interface intf_wl_surface;
extern const struct wp_interface intf_wl_touch;
extern const struct wp_interface intf_wp_presentation;
extern const struct wp_interface intf_wp_presentation_feedback;
extern const struct wp_interface intf_xdg_popup;
extern const struct wp_interface intf_xdg_positioner;
extern const struct wp_interface intf_xdg_surface;
extern const struct wp_interface intf_xdg_toplevel;
extern const struct wp_interface intf_xdg_wm_base;
extern const struct wp_interface intf_zwlr_data_control_device_v1;
extern const struct wp_interface intf_zwlr_data_control_manager_v1;
extern const struct wp_interface intf_zwlr_data_control_offer_v1;
extern const struct wp_interface intf_zwlr_data_control_source_v1;
extern const struct wp_interface intf_zwlr_export_dmabuf_frame_v1;
extern const struct wp_interface intf_zwlr_export_dmabuf_manager_v1;
extern const struct wp_interface intf_zwlr_gamma_control_manager_v1;
extern const struct wp_interface intf_zwlr_gamma_control_v1;
extern const struct wp_interface intf_zwlr_screencopy_frame_v1;
extern const struct wp_interface intf_zwlr_screencopy_manager_v1;
extern const struct wp_interface intf_zwp_input_method_keyboard_grab_v2;
extern const struct wp_interface intf_zwp_input_method_manager_v2;
extern const struct wp_interface intf_zwp_input_method_v2;
extern const struct wp_interface intf_zwp_input_popup_surface_v2;
extern const struct wp_interface intf_zwp_linux_buffer_params_v1;
extern const struct wp_interface intf_zwp_linux_dmabuf_feedback_v1;
extern const struct wp_interface intf_zwp_linux_dmabuf_v1;
extern const struct wp_interface intf_zwp_primary_selection_device_manager_v1;
extern const struct wp_interface intf_zwp_primary_selection_device_v1;
extern const struct wp_interface intf_zwp_primary_selection_offer_v1;
extern const struct wp_interface intf_zwp_primary_selection_source_v1;
extern const struct wp_interface intf_zwp_virtual_keyboard_manager_v1;
extern const struct wp_interface intf_zwp_virtual_keyboard_v1;
#define GTK_PRIMARY_SELECTION_DEVICE_MANAGER_INTERFACE_VERSION 1
#define GTK_PRIMARY_SELECTION_DEVICE_INTERFACE_VERSION 1
#define GTK_PRIMARY_SELECTION_OFFER_INTERFACE_VERSION 1
void do_gtk_primary_selection_offer_req_receive(struct context *ctx, const char *mime_type, int fd);
#define GTK_PRIMARY_SELECTION_SOURCE_INTERFACE_VERSION 1
void do_gtk_primary_selection_source_evt_send(struct context *ctx, const char *mime_type, int fd);
#define ZWP_INPUT_METHOD_V2_INTERFACE_VERSION 1
enum zwp_input_method_v2_error {
	ZWP_INPUT_METHOD_V2_ERROR_ROLE = 0,
};
#define ZWP_INPUT_POPUP_SURFACE_V2_INTERFACE_VERSION 1
#define ZWP_INPUT_METHOD_KEYBOARD_GRAB_V2_INTERFACE_VERSION 1
#define ZWP_INPUT_METHOD_MANAGER_V2_INTERFACE_VERSION 1
#define ZWP_LINUX_DMABUF_V1_INTERFACE_VERSION 4
void do_zwp_linux_dmabuf_v1_evt_modifier(struct context *ctx, uint32_t format, uint32_t modifier_hi, uint32_t modifier_lo);
void do_zwp_linux_dmabuf_v1_req_get_default_feedback(struct context *ctx, struct wp_object *id);
void do_zwp_linux_dmabuf_v1_req_get_surface_feedback(struct context *ctx, struct wp_object *id, struct wp_object *surface);
#define ZWP_LINUX_BUFFER_PARAMS_V1_INTERFACE_VERSION 4
enum zwp_linux_buffer_params_v1_error {
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_ALREADY_USED = 0,
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_PLANE_IDX = 1,
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_PLANE_SET = 2,
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INCOMPLETE = 3,
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INVALID_FORMAT = 4,
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INVALID_DIMENSIONS = 5,
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_OUT_OF_BOUNDS = 6,
	ZWP_LINUX_BUFFER_PARAMS_V1_ERROR_INVALID_WL_BUFFER = 7,
};
void do_zwp_linux_buffer_params_v1_req_add(struct context *ctx, int fd, uint32_t plane_idx, uint32_t offset, uint32_t stride, uint32_t modifier_hi, uint32_t modifier_lo);
enum zwp_linux_buffer_params_v1_flags {
	ZWP_LINUX_BUFFER_PARAMS_V1_FLAGS_Y_INVERT = 1,
	ZWP_LINUX_BUFFER_PARAMS_V1_FLAGS_INTERLACED = 2,
	ZWP_LINUX_BUFFER_PARAMS_V1_FLAGS_BOTTOM_FIRST = 4,
};
void do_zwp_linux_buffer_params_v1_req_create(struct context *ctx, int32_t width, int32_t height, uint32_t format, uint32_t flags);
void do_zwp_linux_buffer_params_v1_evt_created(struct context *ctx, struct wp_object *buffer);
void do_zwp_linux_buffer_params_v1_req_create_immed(struct context *ctx, struct wp_object *buffer_id, int32_t width, int32_t height, uint32_t format, uint32_t flags);
#define ZWP_LINUX_DMABUF_FEEDBACK_V1_INTERFACE_VERSION 4
void do_zwp_linux_dmabuf_feedback_v1_evt_done(struct context *ctx);
void do_zwp_linux_dmabuf_feedback_v1_evt_format_table(struct context *ctx, int fd, uint32_t size);
void do_zwp_linux_dmabuf_feedback_v1_evt_main_device(struct context *ctx, uint32_t device_count, const uint8_t *device_val);
void do_zwp_linux_dmabuf_feedback_v1_evt_tranche_done(struct context *ctx);
void do_zwp_linux_dmabuf_feedback_v1_evt_tranche_target_device(struct context *ctx, uint32_t device_count, const uint8_t *device_val);
void do_zwp_linux_dmabuf_feedback_v1_evt_tranche_formats(struct context *ctx, uint32_t indices_count, const uint8_t *indices_val);
enum zwp_linux_dmabuf_feedback_v1_tranche_flags {
	ZWP_LINUX_DMABUF_FEEDBACK_V1_TRANCHE_FLAGS_SCANOUT = 1,
};
void do_zwp_linux_dmabuf_feedback_v1_evt_tranche_flags(struct context *ctx, uint32_t flags);
#define WP_PRESENTATION_INTERFACE_VERSION 1
enum wp_presentation_error {
	WP_PRESENTATION_ERROR_INVALID_TIMESTAMP = 0,
	WP_PRESENTATION_ERROR_INVALID_FLAG = 1,
};
void do_wp_presentation_req_feedback(struct context *ctx, struct wp_object *surface, struct wp_object *callback);
void do_wp_presentation_evt_clock_id(struct context *ctx, uint32_t clk_id);
#define WP_PRESENTATION_FEEDBACK_INTERFACE_VERSION 1
enum wp_presentation_feedback_kind {
	WP_PRESENTATION_FEEDBACK_KIND_VSYNC = 0x1,
	WP_PRESENTATION_FEEDBACK_KIND_HW_CLOCK = 0x2,
	WP_PRESENTATION_FEEDBACK_KIND_HW_COMPLETION = 0x4,
	WP_PRESENTATION_FEEDBACK_KIND_ZERO_COPY = 0x8,
};
void do_wp_presentation_feedback_evt_presented(struct context *ctx, uint32_t tv_sec_hi, uint32_t tv_sec_lo, uint32_t tv_nsec, uint32_t refresh, uint32_t seq_hi, uint32_t seq_lo, uint32_t flags);
#define ZWP_PRIMARY_SELECTION_DEVICE_MANAGER_V1_INTERFACE_VERSION 1
#define ZWP_PRIMARY_SELECTION_DEVICE_V1_INTERFACE_VERSION 1
#define ZWP_PRIMARY_SELECTION_OFFER_V1_INTERFACE_VERSION 1
void do_zwp_primary_selection_offer_v1_req_receive(struct context *ctx, const char *mime_type, int fd);
#define ZWP_PRIMARY_SELECTION_SOURCE_V1_INTERFACE_VERSION 1
void do_zwp_primary_selection_source_v1_evt_send(struct context *ctx, const char *mime_type, int fd);
#define ZWP_VIRTUAL_KEYBOARD_V1_INTERFACE_VERSION 1
enum zwp_virtual_keyboard_v1_error {
	ZWP_VIRTUAL_KEYBOARD_V1_ERROR_NO_KEYMAP = 0,
};
#define ZWP_VIRTUAL_KEYBOARD_MANAGER_V1_INTERFACE_VERSION 1
enum zwp_virtual_keyboard_manager_v1_error {
	ZWP_VIRTUAL_KEYBOARD_MANAGER_V1_ERROR_UNAUTHORIZED = 0,
};
#define WL_DRM_INTERFACE_VERSION 2
enum wl_drm_error {
	WL_DRM_ERROR_AUTHENTICATE_FAIL = 0,
	WL_DRM_ERROR_INVALID_FORMAT = 1,
	WL_DRM_ERROR_INVALID_NAME = 2,
};
enum wl_drm_format {
	WL_DRM_FORMAT_C8 = 0x20203843,
	WL_DRM_FORMAT_RGB332 = 0x38424752,
	WL_DRM_FORMAT_BGR233 = 0x38524742,
	WL_DRM_FORMAT_XRGB4444 = 0x32315258,
	WL_DRM_FORMAT_XBGR4444 = 0x32314258,
	WL_DRM_FORMAT_RGBX4444 = 0x32315852,
	WL_DRM_FORMAT_BGRX4444 = 0x32315842,
	WL_DRM_FORMAT_ARGB4444 = 0x32315241,
	WL_DRM_FORMAT_ABGR4444 = 0x32314241,
	WL_DRM_FORMAT_RGBA4444 = 0x32314152,
	WL_DRM_FORMAT_BGRA4444 = 0x32314142,
	WL_DRM_FORMAT_XRGB1555 = 0x35315258,
	WL_DRM_FORMAT_XBGR1555 = 0x35314258,
	WL_DRM_FORMAT_RGBX5551 = 0x35315852,
	WL_DRM_FORMAT_BGRX5551 = 0x35315842,
	WL_DRM_FORMAT_ARGB1555 = 0x35315241,
	WL_DRM_FORMAT_ABGR1555 = 0x35314241,
	WL_DRM_FORMAT_RGBA5551 = 0x35314152,
	WL_DRM_FORMAT_BGRA5551 = 0x35314142,
	WL_DRM_FORMAT_RGB565 = 0x36314752,
	WL_DRM_FORMAT_BGR565 = 0x36314742,
	WL_DRM_FORMAT_RGB888 = 0x34324752,
	WL_DRM_FORMAT_BGR888 = 0x34324742,
	WL_DRM_FORMAT_XRGB8888 = 0x34325258,
	WL_DRM_FORMAT_XBGR8888 = 0x34324258,
	WL_DRM_FORMAT_RGBX8888 = 0x34325852,
	WL_DRM_FORMAT_BGRX8888 = 0x34325842,
	WL_DRM_FORMAT_ARGB8888 = 0x34325241,
	WL_DRM_FORMAT_ABGR8888 = 0x34324241,
	WL_DRM_FORMAT_RGBA8888 = 0x34324152,
	WL_DRM_FORMAT_BGRA8888 = 0x34324142,
	WL_DRM_FORMAT_XRGB2101010 = 0x30335258,
	WL_DRM_FORMAT_XBGR2101010 = 0x30334258,
	WL_DRM_FORMAT_RGBX1010102 = 0x30335852,
	WL_DRM_FORMAT_BGRX1010102 = 0x30335842,
	WL_DRM_FORMAT_ARGB2101010 = 0x30335241,
	WL_DRM_FORMAT_ABGR2101010 = 0x30334241,
	WL_DRM_FORMAT_RGBA1010102 = 0x30334152,
	WL_DRM_FORMAT_BGRA1010102 = 0x30334142,
	WL_DRM_FORMAT_YUYV = 0x56595559,
	WL_DRM_FORMAT_YVYU = 0x55595659,
	WL_DRM_FORMAT_UYVY = 0x59565955,
	WL_DRM_FORMAT_VYUY = 0x59555956,
	WL_DRM_FORMAT_AYUV = 0x56555941,
	WL_DRM_FORMAT_XYUV8888 = 0x56555958,
	WL_DRM_FORMAT_NV12 = 0x3231564e,
	WL_DRM_FORMAT_NV21 = 0x3132564e,
	WL_DRM_FORMAT_NV16 = 0x3631564e,
	WL_DRM_FORMAT_NV61 = 0x3136564e,
	WL_DRM_FORMAT_YUV410 = 0x39565559,
	WL_DRM_FORMAT_YVU410 = 0x39555659,
	WL_DRM_FORMAT_YUV411 = 0x31315559,
	WL_DRM_FORMAT_YVU411 = 0x31315659,
	WL_DRM_FORMAT_YUV420 = 0x32315559,
	WL_DRM_FORMAT_YVU420 = 0x32315659,
	WL_DRM_FORMAT_YUV422 = 0x36315559,
	WL_DRM_FORMAT_YVU422 = 0x36315659,
	WL_DRM_FORMAT_YUV444 = 0x34325559,
	WL_DRM_FORMAT_YVU444 = 0x34325659,
};
void do_wl_drm_evt_device(struct context *ctx, const char *name);
enum wl_drm_capability {
	WL_DRM_CAPABILITY_PRIME = 1,
};
void do_wl_drm_req_create_prime_buffer(struct context *ctx, struct wp_object *id, int name, int32_t width, int32_t height, uint32_t format, int32_t offset0, int32_t stride0, int32_t offset1, int32_t stride1, int32_t offset2, int32_t stride2);
#define WL_DISPLAY_INTERFACE_VERSION 1
void do_wl_display_req_sync(struct context *ctx, struct wp_object *callback);
void do_wl_display_req_get_registry(struct context *ctx, struct wp_object *registry);
void do_wl_display_evt_error(struct context *ctx, struct wp_object *object_id, uint32_t code, const char *message);
enum wl_display_error {
	WL_DISPLAY_ERROR_INVALID_OBJECT = 0,
	WL_DISPLAY_ERROR_INVALID_METHOD = 1,
	WL_DISPLAY_ERROR_NO_MEMORY = 2,
	WL_DISPLAY_ERROR_IMPLEMENTATION = 3,
};
void do_wl_display_evt_delete_id(struct context *ctx, uint32_t id);
#define WL_REGISTRY_INTERFACE_VERSION 1
void do_wl_registry_req_bind(struct context *ctx, uint32_t name, const char *interface, uint32_t version, struct wp_object *id);
void do_wl_registry_evt_global(struct context *ctx, uint32_t name, const char *interface, uint32_t version);
void do_wl_registry_evt_global_remove(struct context *ctx, uint32_t name);
#define WL_CALLBACK_INTERFACE_VERSION 1
#define WL_COMPOSITOR_INTERFACE_VERSION 6
#define WL_SHM_POOL_INTERFACE_VERSION 1
void do_wl_shm_pool_req_create_buffer(struct context *ctx, struct wp_object *id, int32_t offset, int32_t width, int32_t height, int32_t stride, uint32_t format);
void do_wl_shm_pool_req_resize(struct context *ctx, int32_t size);
#define WL_SHM_INTERFACE_VERSION 1
enum wl_shm_error {
	WL_SHM_ERROR_INVALID_FORMAT = 0,
	WL_SHM_ERROR_INVALID_STRIDE = 1,
	WL_SHM_ERROR_INVALID_FD = 2,
};
enum wl_shm_format {
	WL_SHM_FORMAT_ARGB8888 = 0,
	WL_SHM_FORMAT_XRGB8888 = 1,
	WL_SHM_FORMAT_C8 = 0x20203843,
	WL_SHM_FORMAT_RGB332 = 0x38424752,
	WL_SHM_FORMAT_BGR233 = 0x38524742,
	WL_SHM_FORMAT_XRGB4444 = 0x32315258,
	WL_SHM_FORMAT_XBGR4444 = 0x32314258,
	WL_SHM_FORMAT_RGBX4444 = 0x32315852,
	WL_SHM_FORMAT_BGRX4444 = 0x32315842,
	WL_SHM_FORMAT_ARGB4444 = 0x32315241,
	WL_SHM_FORMAT_ABGR4444 = 0x32314241,
	WL_SHM_FORMAT_RGBA4444 = 0x32314152,
	WL_SHM_FORMAT_BGRA4444 = 0x32314142,
	WL_SHM_FORMAT_XRGB1555 = 0x35315258,
	WL_SHM_FORMAT_XBGR1555 = 0x35314258,
	WL_SHM_FORMAT_RGBX5551 = 0x35315852,
	WL_SHM_FORMAT_BGRX5551 = 0x35315842,
	WL_SHM_FORMAT_ARGB1555 = 0x35315241,
	WL_SHM_FORMAT_ABGR1555 = 0x35314241,
	WL_SHM_FORMAT_RGBA5551 = 0x35314152,
	WL_SHM_FORMAT_BGRA5551 = 0x35314142,
	WL_SHM_FORMAT_RGB565 = 0x36314752,
	WL_SHM_FORMAT_BGR565 = 0x36314742,
	WL_SHM_FORMAT_RGB888 = 0x34324752,
	WL_SHM_FORMAT_BGR888 = 0x34324742,
	WL_SHM_FORMAT_XBGR8888 = 0x34324258,
	WL_SHM_FORMAT_RGBX8888 = 0x34325852,
	WL_SHM_FORMAT_BGRX8888 = 0x34325842,
	WL_SHM_FORMAT_ABGR8888 = 0x34324241,
	WL_SHM_FORMAT_RGBA8888 = 0x34324152,
	WL_SHM_FORMAT_BGRA8888 = 0x34324142,
	WL_SHM_FORMAT_XRGB2101010 = 0x30335258,
	WL_SHM_FORMAT_XBGR2101010 = 0x30334258,
	WL_SHM_FORMAT_RGBX1010102 = 0x30335852,
	WL_SHM_FORMAT_BGRX1010102 = 0x30335842,
	WL_SHM_FORMAT_ARGB2101010 = 0x30335241,
	WL_SHM_FORMAT_ABGR2101010 = 0x30334241,
	WL_SHM_FORMAT_RGBA1010102 = 0x30334152,
	WL_SHM_FORMAT_BGRA1010102 = 0x30334142,
	WL_SHM_FORMAT_YUYV = 0x56595559,
	WL_SHM_FORMAT_YVYU = 0x55595659,
	WL_SHM_FORMAT_UYVY = 0x59565955,
	WL_SHM_FORMAT_VYUY = 0x59555956,
	WL_SHM_FORMAT_AYUV = 0x56555941,
	WL_SHM_FORMAT_NV12 = 0x3231564e,
	WL_SHM_FORMAT_NV21 = 0x3132564e,
	WL_SHM_FORMAT_NV16 = 0x3631564e,
	WL_SHM_FORMAT_NV61 = 0x3136564e,
	WL_SHM_FORMAT_YUV410 = 0x39565559,
	WL_SHM_FORMAT_YVU410 = 0x39555659,
	WL_SHM_FORMAT_YUV411 = 0x31315559,
	WL_SHM_FORMAT_YVU411 = 0x31315659,
	WL_SHM_FORMAT_YUV420 = 0x32315559,
	WL_SHM_FORMAT_YVU420 = 0x32315659,
	WL_SHM_FORMAT_YUV422 = 0x36315559,
	WL_SHM_FORMAT_YVU422 = 0x36315659,
	WL_SHM_FORMAT_YUV444 = 0x34325559,
	WL_SHM_FORMAT_YVU444 = 0x34325659,
	WL_SHM_FORMAT_R8 = 0x20203852,
	WL_SHM_FORMAT_R16 = 0x20363152,
	WL_SHM_FORMAT_RG88 = 0x38384752,
	WL_SHM_FORMAT_GR88 = 0x38385247,
	WL_SHM_FORMAT_RG1616 = 0x32334752,
	WL_SHM_FORMAT_GR1616 = 0x32335247,
	WL_SHM_FORMAT_XRGB16161616F = 0x48345258,
	WL_SHM_FORMAT_XBGR16161616F = 0x48344258,
	WL_SHM_FORMAT_ARGB16161616F = 0x48345241,
	WL_SHM_FORMAT_ABGR16161616F = 0x48344241,
	WL_SHM_FORMAT_XYUV8888 = 0x56555958,
	WL_SHM_FORMAT_VUY888 = 0x34325556,
	WL_SHM_FORMAT_VUY101010 = 0x30335556,
	WL_SHM_FORMAT_Y210 = 0x30313259,
	WL_SHM_FORMAT_Y212 = 0x32313259,
	WL_SHM_FORMAT_Y216 = 0x36313259,
	WL_SHM_FORMAT_Y410 = 0x30313459,
	WL_SHM_FORMAT_Y412 = 0x32313459,
	WL_SHM_FORMAT_Y416 = 0x36313459,
	WL_SHM_FORMAT_XVYU2101010 = 0x30335658,
	WL_SHM_FORMAT_XVYU12_16161616 = 0x36335658,
	WL_SHM_FORMAT_XVYU16161616 = 0x38345658,
	WL_SHM_FORMAT_Y0L0 = 0x304c3059,
	WL_SHM_FORMAT_X0L0 = 0x304c3058,
	WL_SHM_FORMAT_Y0L2 = 0x324c3059,
	WL_SHM_FORMAT_X0L2 = 0x324c3058,
	WL_SHM_FORMAT_YUV420_8BIT = 0x38305559,
	WL_SHM_FORMAT_YUV420_10BIT = 0x30315559,
	WL_SHM_FORMAT_XRGB8888_A8 = 0x38415258,
	WL_SHM_FORMAT_XBGR8888_A8 = 0x38414258,
	WL_SHM_FORMAT_RGBX8888_A8 = 0x38415852,
	WL_SHM_FORMAT_BGRX8888_A8 = 0x38415842,
	WL_SHM_FORMAT_RGB888_A8 = 0x38413852,
	WL_SHM_FORMAT_BGR888_A8 = 0x38413842,
	WL_SHM_FORMAT_RGB565_A8 = 0x38413552,
	WL_SHM_FORMAT_BGR565_A8 = 0x38413542,
	WL_SHM_FORMAT_NV24 = 0x3432564e,
	WL_SHM_FORMAT_NV42 = 0x3234564e,
	WL_SHM_FORMAT_P210 = 0x30313250,
	WL_SHM_FORMAT_P010 = 0x30313050,
	WL_SHM_FORMAT_P012 = 0x32313050,
	WL_SHM_FORMAT_P016 = 0x36313050,
	WL_SHM_FORMAT_AXBXGXRX106106106106 = 0x30314241,
	WL_SHM_FORMAT_NV15 = 0x3531564e,
	WL_SHM_FORMAT_Q410 = 0x30313451,
	WL_SHM_FORMAT_Q401 = 0x31303451,
	WL_SHM_FORMAT_XRGB16161616 = 0x38345258,
	WL_SHM_FORMAT_XBGR16161616 = 0x38344258,
	WL_SHM_FORMAT_ARGB16161616 = 0x38345241,
	WL_SHM_FORMAT_ABGR16161616 = 0x38344241,
	WL_SHM_FORMAT_C1 = 0x20203143,
	WL_SHM_FORMAT_C2 = 0x20203243,
	WL_SHM_FORMAT_C4 = 0x20203443,
	WL_SHM_FORMAT_D1 = 0x20203144,
	WL_SHM_FORMAT_D2 = 0x20203244,
	WL_SHM_FORMAT_D4 = 0x20203444,
	WL_SHM_FORMAT_D8 = 0x20203844,
	WL_SHM_FORMAT_R1 = 0x20203152,
	WL_SHM_FORMAT_R2 = 0x20203252,
	WL_SHM_FORMAT_R4 = 0x20203452,
	WL_SHM_FORMAT_R10 = 0x20303152,
	WL_SHM_FORMAT_R12 = 0x20323152,
	WL_SHM_FORMAT_AVUY8888 = 0x59555641,
	WL_SHM_FORMAT_XVUY8888 = 0x59555658,
	WL_SHM_FORMAT_P030 = 0x30333050,
};
void do_wl_shm_req_create_pool(struct context *ctx, struct wp_object *id, int fd, int32_t size);
#define WL_BUFFER_INTERFACE_VERSION 1
void do_wl_buffer_evt_release(struct context *ctx);
#define WL_DATA_OFFER_INTERFACE_VERSION 3
enum wl_data_offer_error {
	WL_DATA_OFFER_ERROR_INVALID_FINISH = 0,
	WL_DATA_OFFER_ERROR_INVALID_ACTION_MASK = 1,
	WL_DATA_OFFER_ERROR_INVALID_ACTION = 2,
	WL_DATA_OFFER_ERROR_INVALID_OFFER = 3,
};
void do_wl_data_offer_req_receive(struct context *ctx, const char *mime_type, int fd);
#define WL_DATA_SOURCE_INTERFACE_VERSION 3
enum wl_data_source_error {
	WL_DATA_SOURCE_ERROR_INVALID_ACTION_MASK = 0,
	WL_DATA_SOURCE_ERROR_INVALID_SOURCE = 1,
};
void do_wl_data_source_evt_send(struct context *ctx, const char *mime_type, int fd);
#define WL_DATA_DEVICE_INTERFACE_VERSION 3
enum wl_data_device_error {
	WL_DATA_DEVICE_ERROR_ROLE = 0,
};
#define WL_DATA_DEVICE_MANAGER_INTERFACE_VERSION 3
enum wl_data_device_manager_dnd_action {
	WL_DATA_DEVICE_MANAGER_DND_ACTION_NONE = 0,
	WL_DATA_DEVICE_MANAGER_DND_ACTION_COPY = 1,
	WL_DATA_DEVICE_MANAGER_DND_ACTION_MOVE = 2,
	WL_DATA_DEVICE_MANAGER_DND_ACTION_ASK = 4,
};
#define WL_SHELL_INTERFACE_VERSION 1
enum wl_shell_error {
	WL_SHELL_ERROR_ROLE = 0,
};
#define WL_SHELL_SURFACE_INTERFACE_VERSION 1
enum wl_shell_surface_resize {
	WL_SHELL_SURFACE_RESIZE_NONE = 0,
	WL_SHELL_SURFACE_RESIZE_TOP = 1,
	WL_SHELL_SURFACE_RESIZE_BOTTOM = 2,
	WL_SHELL_SURFACE_RESIZE_LEFT = 4,
	WL_SHELL_SURFACE_RESIZE_TOP_LEFT = 5,
	WL_SHELL_SURFACE_RESIZE_BOTTOM_LEFT = 6,
	WL_SHELL_SURFACE_RESIZE_RIGHT = 8,
	WL_SHELL_SURFACE_RESIZE_TOP_RIGHT = 9,
	WL_SHELL_SURFACE_RESIZE_BOTTOM_RIGHT = 10,
};
enum wl_shell_surface_transient {
	WL_SHELL_SURFACE_TRANSIENT_INACTIVE = 0x1,
};
enum wl_shell_surface_fullscreen_method {
	WL_SHELL_SURFACE_FULLSCREEN_METHOD_DEFAULT = 0,
	WL_SHELL_SURFACE_FULLSCREEN_METHOD_SCALE = 1,
	WL_SHELL_SURFACE_FULLSCREEN_METHOD_DRIVER = 2,
	WL_SHELL_SURFACE_FULLSCREEN_METHOD_FILL = 3,
};
#define WL_SURFACE_INTERFACE_VERSION 6
enum wl_surface_error {
	WL_SURFACE_ERROR_INVALID_SCALE = 0,
	WL_SURFACE_ERROR_INVALID_TRANSFORM = 1,
	WL_SURFACE_ERROR_INVALID_SIZE = 2,
	WL_SURFACE_ERROR_INVALID_OFFSET = 3,
	WL_SURFACE_ERROR_DEFUNCT_ROLE_OBJECT = 4,
};
void do_wl_surface_req_attach(struct context *ctx, struct wp_object *buffer, int32_t x, int32_t y);
void do_wl_surface_req_damage(struct context *ctx, int32_t x, int32_t y, int32_t width, int32_t height);
void do_wl_surface_req_commit(struct context *ctx);
void do_wl_surface_req_set_buffer_transform(struct context *ctx, int32_t transform);
void do_wl_surface_req_set_buffer_scale(struct context *ctx, int32_t scale);
void do_wl_surface_req_damage_buffer(struct context *ctx, int32_t x, int32_t y, int32_t width, int32_t height);
#define WL_SEAT_INTERFACE_VERSION 9
enum wl_seat_capability {
	WL_SEAT_CAPABILITY_POINTER = 1,
	WL_SEAT_CAPABILITY_KEYBOARD = 2,
	WL_SEAT_CAPABILITY_TOUCH = 4,
};
enum wl_seat_error {
	WL_SEAT_ERROR_MISSING_CAPABILITY = 0,
};
#define WL_POINTER_INTERFACE_VERSION 9
enum wl_pointer_error {
	WL_POINTER_ERROR_ROLE = 0,
};
enum wl_pointer_button_state {
	WL_POINTER_BUTTON_STATE_RELEASED = 0,
	WL_POINTER_BUTTON_STATE_PRESSED = 1,
};
enum wl_pointer_axis {
	WL_POINTER_AXIS_VERTICAL_SCROLL = 0,
	WL_POINTER_AXIS_HORIZONTAL_SCROLL = 1,
};
enum wl_pointer_axis_source {
	WL_POINTER_AXIS_SOURCE_WHEEL = 0,
	WL_POINTER_AXIS_SOURCE_FINGER = 1,
	WL_POINTER_AXIS_SOURCE_CONTINUOUS = 2,
	WL_POINTER_AXIS_SOURCE_WHEEL_TILT = 3,
};
enum wl_pointer_axis_relative_direction {
	WL_POINTER_AXIS_RELATIVE_DIRECTION_IDENTICAL = 0,
	WL_POINTER_AXIS_RELATIVE_DIRECTION_INVERTED = 1,
};
#define WL_KEYBOARD_INTERFACE_VERSION 9
enum wl_keyboard_keymap_format {
	WL_KEYBOARD_KEYMAP_FORMAT_NO_KEYMAP = 0,
	WL_KEYBOARD_KEYMAP_FORMAT_XKB_V1 = 1,
};
void do_wl_keyboard_evt_keymap(struct context *ctx, uint32_t format, int fd, uint32_t size);
enum wl_keyboard_key_state {
	WL_KEYBOARD_KEY_STATE_RELEASED = 0,
	WL_KEYBOARD_KEY_STATE_PRESSED = 1,
};
#define WL_TOUCH_INTERFACE_VERSION 9
#define WL_OUTPUT_INTERFACE_VERSION 4
enum wl_output_subpixel {
	WL_OUTPUT_SUBPIXEL_UNKNOWN = 0,
	WL_OUTPUT_SUBPIXEL_NONE = 1,
	WL_OUTPUT_SUBPIXEL_HORIZONTAL_RGB = 2,
	WL_OUTPUT_SUBPIXEL_HORIZONTAL_BGR = 3,
	WL_OUTPUT_SUBPIXEL_VERTICAL_RGB = 4,
	WL_OUTPUT_SUBPIXEL_VERTICAL_BGR = 5,
};
enum wl_output_transform {
	WL_OUTPUT_TRANSFORM_NORMAL = 0,
	WL_OUTPUT_TRANSFORM_90 = 1,
	WL_OUTPUT_TRANSFORM_180 = 2,
	WL_OUTPUT_TRANSFORM_270 = 3,
	WL_OUTPUT_TRANSFORM_FLIPPED = 4,
	WL_OUTPUT_TRANSFORM_FLIPPED_90 = 5,
	WL_OUTPUT_TRANSFORM_FLIPPED_180 = 6,
	WL_OUTPUT_TRANSFORM_FLIPPED_270 = 7,
};
enum wl_output_mode {
	WL_OUTPUT_MODE_CURRENT = 0x1,
	WL_OUTPUT_MODE_PREFERRED = 0x2,
};
#define WL_REGION_INTERFACE_VERSION 1
#define WL_SUBCOMPOSITOR_INTERFACE_VERSION 1
enum wl_subcompositor_error {
	WL_SUBCOMPOSITOR_ERROR_BAD_SURFACE = 0,
	WL_SUBCOMPOSITOR_ERROR_BAD_PARENT = 1,
};
#define WL_SUBSURFACE_INTERFACE_VERSION 1
enum wl_subsurface_error {
	WL_SUBSURFACE_ERROR_BAD_SURFACE = 0,
};
#define ZWLR_DATA_CONTROL_MANAGER_V1_INTERFACE_VERSION 2
#define ZWLR_DATA_CONTROL_DEVICE_V1_INTERFACE_VERSION 2
enum zwlr_data_control_device_v1_error {
	ZWLR_DATA_CONTROL_DEVICE_V1_ERROR_USED_SOURCE = 1,
};
#define ZWLR_DATA_CONTROL_SOURCE_V1_INTERFACE_VERSION 1
enum zwlr_data_control_source_v1_error {
	ZWLR_DATA_CONTROL_SOURCE_V1_ERROR_INVALID_OFFER = 1,
};
void do_zwlr_data_control_source_v1_evt_send(struct context *ctx, const char *mime_type, int fd);
#define ZWLR_DATA_CONTROL_OFFER_V1_INTERFACE_VERSION 1
void do_zwlr_data_control_offer_v1_req_receive(struct context *ctx, const char *mime_type, int fd);
#define ZWLR_EXPORT_DMABUF_MANAGER_V1_INTERFACE_VERSION 1
#define ZWLR_EXPORT_DMABUF_FRAME_V1_INTERFACE_VERSION 1
enum zwlr_export_dmabuf_frame_v1_flags {
	ZWLR_EXPORT_DMABUF_FRAME_V1_FLAGS_TRANSIENT = 0x1,
};
void do_zwlr_export_dmabuf_frame_v1_evt_frame(struct context *ctx, uint32_t width, uint32_t height, uint32_t offset_x, uint32_t offset_y, uint32_t buffer_flags, uint32_t flags, uint32_t format, uint32_t mod_high, uint32_t mod_low, uint32_t num_objects);
void do_zwlr_export_dmabuf_frame_v1_evt_object(struct context *ctx, uint32_t index, int fd, uint32_t size, uint32_t offset, uint32_t stride, uint32_t plane_index);
void do_zwlr_export_dmabuf_frame_v1_evt_ready(struct context *ctx, uint32_t tv_sec_hi, uint32_t tv_sec_lo, uint32_t tv_nsec);
enum zwlr_export_dmabuf_frame_v1_cancel_reason {
	ZWLR_EXPORT_DMABUF_FRAME_V1_CANCEL_REASON_TEMPORARY = 0,
	ZWLR_EXPORT_DMABUF_FRAME_V1_CANCEL_REASON_PERMANENT = 1,
	ZWLR_EXPORT_DMABUF_FRAME_V1_CANCEL_REASON_RESIZING = 2,
};
#define ZWLR_GAMMA_CONTROL_MANAGER_V1_INTERFACE_VERSION 1
#define ZWLR_GAMMA_CONTROL_V1_INTERFACE_VERSION 1
enum zwlr_gamma_control_v1_error {
	ZWLR_GAMMA_CONTROL_V1_ERROR_INVALID_GAMMA = 1,
};
void do_zwlr_gamma_control_v1_req_set_gamma(struct context *ctx, int fd);
#define ZWLR_SCREENCOPY_MANAGER_V1_INTERFACE_VERSION 3
#define ZWLR_SCREENCOPY_FRAME_V1_INTERFACE_VERSION 3
void do_zwlr_screencopy_frame_v1_req_copy(struct context *ctx, struct wp_object *buffer);
enum zwlr_screencopy_frame_v1_error {
	ZWLR_SCREENCOPY_FRAME_V1_ERROR_ALREADY_USED = 0,
	ZWLR_SCREENCOPY_FRAME_V1_ERROR_INVALID_BUFFER = 1,
};
enum zwlr_screencopy_frame_v1_flags {
	ZWLR_SCREENCOPY_FRAME_V1_FLAGS_Y_INVERT = 1,
};
void do_zwlr_screencopy_frame_v1_evt_ready(struct context *ctx, uint32_t tv_sec_hi, uint32_t tv_sec_lo, uint32_t tv_nsec);
#define XDG_WM_BASE_INTERFACE_VERSION 3
enum xdg_wm_base_error {
	XDG_WM_BASE_ERROR_ROLE = 0,
	XDG_WM_BASE_ERROR_DEFUNCT_SURFACES = 1,
	XDG_WM_BASE_ERROR_NOT_THE_TOPMOST_POPUP = 2,
	XDG_WM_BASE_ERROR_INVALID_POPUP_PARENT = 3,
	XDG_WM_BASE_ERROR_INVALID_SURFACE_STATE = 4,
	XDG_WM_BASE_ERROR_INVALID_POSITIONER = 5,
};
#define XDG_POSITIONER_INTERFACE_VERSION 3
enum xdg_positioner_error {
	XDG_POSITIONER_ERROR_INVALID_INPUT = 0,
};
enum xdg_positioner_anchor {
	XDG_POSITIONER_ANCHOR_NONE = 0,
	XDG_POSITIONER_ANCHOR_TOP = 1,
	XDG_POSITIONER_ANCHOR_BOTTOM = 2,
	XDG_POSITIONER_ANCHOR_LEFT = 3,
	XDG_POSITIONER_ANCHOR_RIGHT = 4,
	XDG_POSITIONER_ANCHOR_TOP_LEFT = 5,
	XDG_POSITIONER_ANCHOR_BOTTOM_LEFT = 6,
	XDG_POSITIONER_ANCHOR_TOP_RIGHT = 7,
	XDG_POSITIONER_ANCHOR_BOTTOM_RIGHT = 8,
};
enum xdg_positioner_gravity {
	XDG_POSITIONER_GRAVITY_NONE = 0,
	XDG_POSITIONER_GRAVITY_TOP = 1,
	XDG_POSITIONER_GRAVITY_BOTTOM = 2,
	XDG_POSITIONER_GRAVITY_LEFT = 3,
	XDG_POSITIONER_GRAVITY_RIGHT = 4,
	XDG_POSITIONER_GRAVITY_TOP_LEFT = 5,
	XDG_POSITIONER_GRAVITY_BOTTOM_LEFT = 6,
	XDG_POSITIONER_GRAVITY_TOP_RIGHT = 7,
	XDG_POSITIONER_GRAVITY_BOTTOM_RIGHT = 8,
};
enum xdg_positioner_constraint_adjustment {
	XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_NONE = 0,
	XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_X = 1,
	XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_SLIDE_Y = 2,
	XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_X = 4,
	XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_FLIP_Y = 8,
	XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_X = 16,
	XDG_POSITIONER_CONSTRAINT_ADJUSTMENT_RESIZE_Y = 32,
};
#define XDG_SURFACE_INTERFACE_VERSION 3
enum xdg_surface_error {
	XDG_SURFACE_ERROR_NOT_CONSTRUCTED = 1,
	XDG_SURFACE_ERROR_ALREADY_CONSTRUCTED = 2,
	XDG_SURFACE_ERROR_UNCONFIGURED_BUFFER = 3,
};
#define XDG_TOPLEVEL_INTERFACE_VERSION 3
void do_xdg_toplevel_req_set_title(struct context *ctx, const char *title);
enum xdg_toplevel_resize_edge {
	XDG_TOPLEVEL_RESIZE_EDGE_NONE = 0,
	XDG_TOPLEVEL_RESIZE_EDGE_TOP = 1,
	XDG_TOPLEVEL_RESIZE_EDGE_BOTTOM = 2,
	XDG_TOPLEVEL_RESIZE_EDGE_LEFT = 4,
	XDG_TOPLEVEL_RESIZE_EDGE_TOP_LEFT = 5,
	XDG_TOPLEVEL_RESIZE_EDGE_BOTTOM_LEFT = 6,
	XDG_TOPLEVEL_RESIZE_EDGE_RIGHT = 8,
	XDG_TOPLEVEL_RESIZE_EDGE_TOP_RIGHT = 9,
	XDG_TOPLEVEL_RESIZE_EDGE_BOTTOM_RIGHT = 10,
};
enum xdg_toplevel_state {
	XDG_TOPLEVEL_STATE_MAXIMIZED = 1,
	XDG_TOPLEVEL_STATE_FULLSCREEN = 2,
	XDG_TOPLEVEL_STATE_RESIZING = 3,
	XDG_TOPLEVEL_STATE_ACTIVATED = 4,
	XDG_TOPLEVEL_STATE_TILED_LEFT = 5,
	XDG_TOPLEVEL_STATE_TILED_RIGHT = 6,
	XDG_TOPLEVEL_STATE_TILED_TOP = 7,
	XDG_TOPLEVEL_STATE_TILED_BOTTOM = 8,
};
#define XDG_POPUP_INTERFACE_VERSION 3
enum xdg_popup_error {
	XDG_POPUP_ERROR_INVALID_GRAB = 0,
};

#endif /* PROTOCOLS_H */
